<?php 
/* ============================================================================
 * User is a resource that can connect to the application.
 */  
require_once('_securityCheck.php');
class Affectable extends SqlElement {

  // extends SqlElement, so has $id
  public $_col_1_2_Description;
  public $id;    // redefine $id to specify its visible place 
  public $name;
  public $userName;
  public $isResource;
  public $isUser;
  public $isContact;
  public $email;
  public $idTeam;
  public $idle;
  
  public $_constructForName=true;
  public $_calculateForColumn=array("name"=>"coalesce(fullName,concat(name,' #'))",
                                    "userName"=>"coalesce(name,concat(fullName,' *'))");
  
  private static $_fieldsAttributes=array("name"=>"required", 
                                          "isContact"=>"readonly",
                                          "isUser"=>"readonly",
                                          "isResource"=>"readonly",
                                          "idle"=>"hidden" 
  );    
  
  private static $_databaseTableName = 'resource';

  private static $_databaseColumnName = array('name'=>'fullName',
                                              'userName'=>'name');

  private static $_databaseCriteria = array();
  
  /** ==========================================================================
   * Constructor
   * @param $id the id of the object in the database (null if not stored yet)
   * @return void
   */ 
  function __construct($id = NULL) {
    parent::__construct($id);
    if ($this->id and !$this->name and $this->userName) {
      $this->name=$this->userName;
    }
  }

  
  /** ==========================================================================
   * Destructor
   * @return void
   */ 
  function __destruct() {
    parent::__destruct();
  }

// ============================================================================**********
// GET STATIC DATA FUNCTIONS
// ============================================================================**********

  /** ========================================================================
   * Return the specific databaseTableName
   * @return the databaseTableName
   */
  protected function getStaticDatabaseTableName() {
    $paramDbPrefix=Parameter::getGlobalParameter('paramDbPrefix');
    return $paramDbPrefix . self::$_databaseTableName;
  }

  /** ========================================================================
   * Return the specific databaseTableName
   * @return the databaseTableName
   */
  protected function getStaticDatabaseColumnName() {
    return self::$_databaseColumnName;
  }
  
  /** ========================================================================
   * Return the specific database criteria
   * @return the databaseTableName
   */
  protected function getStaticDatabaseCriteria() {
    return self::$_databaseCriteria;
  }

     /** ==========================================================================
   * Return the specific fieldsAttributes
   * @return the fieldsAttributes
   */
  protected function getStaticFieldsAttributes() {
    return self::$_fieldsAttributes;
  }
  
}
?>